
//lcd.h
//use vim

#ifndef	LCD_H
#define	LCD_H 1

#define	LCD_CTRL_PORT	PORTF
#define	LCD_CTRL_DDR 	DDRF
#define	LCD_CE		PF2
#define	LCD_DC		PF0
#define	LCD_RST		PF3
#define	CMD	0xff
#define	DATA	0x00

/* bit operation */
#define SETBIT(x,y) (x |= _BV(y))
#define CLRBIT(x,y) (x &=~ _BV(y))
#define CHKBIT(x,y) (x & _BV(y))
#define INVBIT(x,y) (x ^= _BV(y))

//declare functions
extern void lcd_init(void);
extern void lcd_screen_clean(void);
extern void lcd_set_location(uint8_t x,uint8_t y);
extern void lcd_put_char(uint8_t disp_char);
extern void lcd_put_string(const char *disp_string);

extern void lcd_put_int(int16_t d);

extern void lcd_disp_dec(uint8_t hex_data);
extern void lcd_disp_dec2(uint8_t hex_data);
extern void lcd_disp_play_time(uint16_t decode_time);

extern void init_cn(void);
extern uint8_t read_one_gbk12(uint8_t *c);
extern uint8_t unicode_to_gbk(uint8_t *c);
extern uint8_t put_LCD_uni(uint8_t x, uint8_t y, uint8_t *str);
extern uint8_t put_LCD_gbk(uint8_t x, uint8_t y, uint8_t *str);
extern void test_cn_display(void);

extern void lcd_put_char_cn(uint8_t x, uint8_t y,const uint8_t *addr);
extern void lcd_put_string_cn(uint8_t x, uint8_t y, const uint8_t *addr, uint8_t str_len);

#endif
//end of file
