
//sd.h

#ifndef _SD_H
#define _SD_H 1

/* *******************************
 * SD 卡引脚连接
 * 1 SDCS ---  PB0(SS)
 * 7 DOUT ---  MISO
 * 2 DIN  ---  MOSI
 * 5 SCLK ---  SCK
 * 3 6 VSS
 * 4   VDD
 * 8 9 PULL UP
 * *******************************/
#define	SD_PORT	PORTB
#define	SD_DDR	DDRB
#define	SD_PIN	PINB
#define	SD_CS	PB0

#define	ENABLE_SD	CLRBIT(SD_PORT, SD_CS)
#define	DISABLE_SD	SETBIT(SD_PORT, SD_CS)

//function prototype
extern uint8_t sd_init(void);
extern uint8_t sd_read_block(uint32_t sector, uint8_t * sd_buffer);

#endif

//end of file
