
//spi.h
#ifndef		SPI_H
#define		SPI_H 1

//ATmega64
#define		SPI_PORT	PORTB
#define		SPI_DDR		DDRB
#define		SPI_SCK		PB1
#define		SPI_MOSI	PB2
#define		SPI_MISO	PB3
#define		SPI_SS		PB0

#define		HIGH_SPEED 	1
#define		LOW_SPEED	0

/* bit operation */
#define SETBIT(x,y) (x |= _BV(y))
#define CLRBIT(x,y) (x &=~ _BV(y))
#define CHKBIT(x,y) (x & _BV(y))
#define INVBIT(x,y) (x ^= _BV(y))

extern void spi_io_init(void);
extern void enable_spi_master(uint8_t spi_speed);
extern uint8_t spi_access_byte(uint8_t d);

#endif		//SPI_H
