

#ifndef USART_H_
#define USART_H_

#define BUADRATE 38400

#if U2X_
#define	UBRR_VALUE (unsigned short)(F_CPU / (8UL * BUADRATE) - 1)
#else
#define UBRR_VALUE (unsigned short)(F_CPU / (16UL * BUADRATE) - 1)
#endif

#define UBRRH_VALUE (UBRR_VALUE / 256)
#define UBRRL_VALUE (UBRR_VALUE % 256)

#define CHECK_RXC CHKBIT(UCSR0A, RXC)

/* bit operation */
#define SETBIT(x,y) (x |= _BV(y))
#define CLRBIT(x,y) (x &=~ _BV(y))
#define CHKBIT(x,y) (x & _BV(y))
#define INVBIT(x,y) (x ^= _BV(y))

#define GLUE(a,b)  (a##b)
#define PORT(x) GLUE(PORT,x)
#define DDR(x)  GLUE(DDR,x)
#define PIN(x)  GLUE(PIN,x)

extern void usart_init(void);
extern void write_udr(unsigned char c);
extern unsigned char read_udr(void);
extern void put_string_ram(const char *str);
extern void put_string_f(const char *str);
extern void put_int(int16_t d);
extern void put_cr_lf(void);

#endif
