
//vs1003.h

/* ********************************************
 *
 * M64          VS1003B
 *
 * PB1(SCK)	PIN28(SCLK)		时钟
 * PB2(MOSI)	PIN29(SI)		主出从入		
 * PB3(MISO)	PIN30(SO)		主入从出
 * PB4		PIN23(XCS)		片选
 * PB5		PIN3(XRESET)		复位
 * PB6		PIN8(DREQ)		数据请求
 * PB7		PIN13(XDCS)		数据片选
 *
 * ********************************************/

#ifndef 	VS1003B_H
#define		VS1003B_H

#define		VS_CTRL_PORT	PORTB
#define		VS_CTRL_DDR	DDRB
#define		VS_CTRL_PIN	PINB

#define		VS_SCLK		PB1
#define		VS_SI		PB2
#define		VS_SO		PB3	//SPI init
#define		VS_XCS		PB4
#define		VS_XRST		PB5
#define		VS_DREQ		PB6
#define		VS_XDCS		PB7

#define	WRITE	0x02
#define	READ	0x03

/* bit operation */
#define SETBIT(x,y) (x |= _BV(y))
#define CLRBIT(x,y) (x &=~ _BV(y))
#define CHKBIT(x,y) (x & _BV(y))
#define INVBIT(x,y) (x ^= _BV(y))

#define	CHK_DREQ	CHKBIT(VS_CTRL_PIN, VS_DREQ)//不要写成CHKBIT(VS_CTRL_PORT, VS_DREQ)
#define	ENABLE_DATA_CS 	CLRBIT(VS_CTRL_PORT, VS_XDCS); SETBIT(VS_CTRL_PORT, VS_XCS)
#define	ENABLE_CMD_CS 	SETBIT(VS_CTRL_PORT, VS_XDCS); CLRBIT(VS_CTRL_PORT, VS_XCS)
#define	DISABLE_CS	SETBIT(VS_CTRL_PORT, VS_XDCS); SETBIT(VS_CTRL_PORT, VS_XCS)

#define	SET_OUT_MASK	(_BV(VS_SCLK)|_BV(VS_SI)|_BV(VS_XCS)|_BV(VS_XRST)|_BV(VS_XDCS))
#define	SET_IN_MASK	(_BV(VS_SO)|_BV(VS_DREQ))
#define	VS_CTRL_MASK	(_BV(VS_SCLK)|_BV(VS_SI)|_BV(VS_SO)|_BV(VS_XCS)|_BV(VS_XRST)|_BV(VS_XDCS)|_BV(VS_DREQ))

//function prototypes
extern void vs1003_init(void);
extern uint16_t vs_read_cmd(uint8_t addr);
extern void vs_write_cmd(uint8_t addr, uint16_t d);
extern void vs_write_data(uint8_t data);

extern void vs1003b_soft_reset(void);
extern uint16_t vs_read_decode_time(void);
extern void vs_clear_decode_time(void);


#endif	//VS1003_H
//end of vs1003.h
